/*
 * =====================================================================================
 *
 *       Filename:  GraphReader.h
 *
 *    Description:  The definition of class GraphReader
 *
 *        Version:  1.0
 *        Created:  04/21/2008 07:57:13 PM
 *       Revision:  none
 *       Compiler:  g++
 *
 *         Author:  Jianxing Feng (feeldead), feeldead@gmail.com
 *        Company:  THU
 *
 * =====================================================================================
 */

#ifndef GraphReader_h
#define GraphReader_h

class Graph;
/*
 * =====================================================================================
 *        Class:  GraphReader
 *  Description:  The base class for graph readers. Any form of creating a graph could
 *                be considered as read from a reader.
 * =====================================================================================
 */
class GraphReader
{
	public:
		/* ====================  LIFECYCLE     ======================================= */
		GraphReader ();                             /* constructor */
		virtual ~GraphReader (){};                             /* constructor */

		/* ====================  OPERATORS     ======================================= */
		virtual bool SetGraph (Graph* pGraph);
		virtual bool Read ();

		/* ====================  OPERATIONS    ======================================= */

		/* ====================  ACCESS        ======================================= */

		/* ====================  INQUIRY       ======================================= */

		/* ====================  DATA MEMBERS  ======================================= */
	protected:
		Graph* 	mpGraph;

	private:

}; /* -----  end of class  GraphReader  ----- */

#endif
